
//////////////////////////////////////////////////////////////
//
// Source file for DisplayWindowMainWindow
//
//    This class is a subclass of VkSimpleWindow
//
//
// Normally, very little in this file should need to be changed.
// Create/add/modify menus using RapidApp.
//
// Try to restrict any changes to the bodies of functions
// corresponding to menu items, the constructor and destructor.
//
// Restrict changes to those sections between
// the "//--- Start/End editable code block" markers
//
// Doing so will allow you to make changes using RapidApp
// without losing any changes you may have made manually
//
// Avoid gratuitous reformatting and other changes that might
// make it difficult to integrate changes made using RapidApp
//////////////////////////////////////////////////////////////
#include "DisplayWindowMainWindow.h"

#include <Vk/VkApp.h>
#include <Vk/VkResource.h>


// Externally defined classes referenced by this class: 

#include "Dpy_form.h"

extern void VkUnimplemented ( Widget, const char * );

//---- Start editable code block: headers and declarations


//---- End editable code block: headers and declarations



// These are default resources for widgets in objects of this class
// All resources will be prepended by *<name> at instantiation,
// where <name> is the name of the specific instance, as well as the
// name of the baseWidget. These are only defaults, and may be overriden
// in a resource file by providing a more specific resource name

String  DisplayWindowMainWindow::_defaultDisplayWindowMainWindowResources[] = {
        "*title:  Video Display",

        //---- Start editable code block: DisplayWindowMainWindow Default Resources


        //---- End editable code block: DisplayWindowMainWindow Default Resources

        (char*)NULL
};


//---- Class declaration

DisplayWindowMainWindow::DisplayWindowMainWindow ( const char *name,
                                                  ArgList args,
                                                  Cardinal argCount) : 
                                            VkSimpleWindow ( name, args, argCount )
{
    // Load any class-default resources for this object

    setDefaultResources ( baseWidget(), _defaultDisplayWindowMainWindowResources  );


    // Create the view component contained by this window

    _dpy_form = new Dpy_form ( "dpy_form",mainWindowWidget() );


    XtVaSetValues ( _dpy_form->baseWidget(),
                    XmNwidth, 176, 
                    XmNheight, 215, 
                    (XtPointer) NULL );

    // Add the component as the main view

    addView ( _dpy_form );

    // Set up the window manager properties for this window.
    // This window cannot be resized by the user.

     VkConfigureWM ( this,
                    FALSE,  //quit
                    FALSE,  // close
                    FALSE,   // border
                    TRUE,   // title
                    FALSE,  // allow resize
                    TRUE,   // allow iconify
                    FALSE);  // Show window manager menu

    //---- Start editable code block: DisplayWindowMainWindow constructor


    //---- End editable code block: DisplayWindowMainWindow constructor


}    // End Constructor


DisplayWindowMainWindow::~DisplayWindowMainWindow()
{
    delete _dpy_form;
    //---- Start editable code block: DisplayWindowMainWindow destructor


    //---- End editable code block: DisplayWindowMainWindow destructor
}    // End destructor


const char *DisplayWindowMainWindow::className()
{
    return ("DisplayWindowMainWindow");
}    // End className()


Boolean DisplayWindowMainWindow::okToQuit()
{
    //---- Start editable code block: DisplayWindowMainWindow okToQuit



    // This member function is called when the user quits by calling
    // theApplication->terminate() or uses the window manager close protocol
    // This function can abort the operation by returning FALSE, or do some.
    // cleanup before returning TRUE. The actual decision is normally passed on
    // to the view object


    // Query the view object, and give it a chance to cleanup

    return ( _dpy_form->okToQuit() );

    //---- End editable code block: DisplayWindowMainWindow okToQuit
}    // End okToQuit()





/////////////////////////////////////////////////////////////// 
// The following functions are called from callbacks 
/////////////////////////////////// 




//---- Start editable code block: End of generated code

void DisplayWindowMainWindow::setStatus(char *text)
{
  _dpy_form->setStatus(text);
}

void DisplayWindowMainWindow::setStatistics(char *fps, char *kbps)
{
  _dpy_form->setStatistics(fps, kbps);
}

//---- End editable code block: End of generated code


